        org  32768

MCTRAP: dec  sp
        dec  sp
        bit  4,(iy+$01)
        jr   z,MODE48
        ld   a,(19)
        inc  a               ;A =168 if +2A/+3 else 0
        ld   l,a
        ld   a,(5440)        ;A =83 if Sinclair else 65 if Amstrad
        add  a,l             ;A =83 +128k; =65 +2; =233 +2A/+3/+3e
        cp   233
        jr   z,PLUS3M
MODE48: ld   hl,$1b9e        ;LINE-NEW
        push hl
        jr   MCCONT
PLUS3M: ld   hl,$1031        ;STMT-RET (+2A/+3/+3e ROM.1)
        push hl
        ld   hl,$5b2f        ;REGNUOY  (+2A/+3/+3e paging)
        push hl
MCCONT: LD   HL,(23621)      ;save PPC current line
        LD   (23615),HL      ;in LIST_SP
        LD   A,(23610)       ;save ERR_NR error code
        LD   (23681),A       ;in "not used"
        LD   A,$ff
        LD   (23610),A       ;reset error code
        LD   HL,9000         ;line number of BASIC error handler
        ld   a,1             ;statement number
        ld   d,a
MCLOOP: CALL $1f54           ;BREAK-KEY
        JP   C,$1e73         ;GO-TO-2 - jump if not BREAK
        JR   MCLOOP          ;ignore BREAK

MODESW: ld   a,(75)
        cp   191
        ret  z               ;16k/48k
        bit  4,(iy+$01)
        jr   nz,TO48
TO128:  set  4,(iy+$01)      ;signal "128K BASIC" mode
        jr   TO_ALL
TO48:   res  4,(iy+$01)      ;signal "48K BASIC" mode
        ld   hl,($5C4F)      ;(CHANS)
        ld   de,$0005
        add  hl,de           ;HL=channel info for "S"
        ld   de,$000a
        ex   de,hl
        add  hl,de
        ex   de,hl           ;DE=channel info for "P"
        ld   bc,$0004
        ldir                 ;replace channel info "P" with "S"
TO_ALL: ld   sp,($5c3d)      ;ERR_SP
        ld   hl,$0014        ;address of $FF in BASIC ROM, for report "0 OK"
        push hl
        ld   hl,$0008        ;address of ERROR_1
        push hl
        ret
